#!/usr/bin/perl5
#
# Monitor a set of web pages for accesses; each time one is accessed, emit
# its contents a la Netscape server push.  For Apache, this requires NPH.
#

#
# This is the "boundary"; a pattern used to signal Netscape that this is a 
# new document.  This particular pattern was good enough for the Netscape
# server push documentation, so it's good enough for us.
#
$boundary = 'ThisRandomString';
#
# This file is included by all the files, so that we can just monitor one file.
#
$monitor = '/usr/users/rose/www/feed/doggy';
#
# @pagePats is a number of filename patterns that are globbed to get a list of
# all the files in the set that are eligible for display.
#
@pagePats = ('/usr/users/rose/www/feed/*.html');
for $pagePat (@pagePats) {
    push @pages, glob($pagePat);
}
#
# This is the first document emitted.
#
$first = '/usr/users/rose/www/feed/index.html';
#
# Buffer not.
#
$| = 1;
#
# NPH requires that we emit a full set of headers.  This code is from Craig 
# Horman.
#
$ENV{'TZ'} = 'GMT';
$date = `date '+%a, %e %h %Y %X %Z'`;
chomp $date;
print "$ENV{'SERVER_PROTOCOL'} 200 OK
Date: $date
Server: $ENV{'SERVER_SOFTWARE'}
";
print "Connection: close\n" if($ENV{'SERVER_PROTOCOL'} =~ m^HTTP/1\.1]^);
print
"Content-type: multipart/x-mixed-replace;boundary=$boundary

";
emit($first);
while($next = monitor()) {
    emit($next);
}


sub emit {
    print 
"--$boundary
Content-type: text/html

";
    (open F, $_[0]) || die "can't open \"$_[0]\"";
    while(<F>) {
	print;
    }
    close F;

} # end emit() 


sub monitor {
    my($atime, $atime2);

    # Check the access time.

    $atime = (stat $monitor)[8];
    do {

	# Sleep, then check it again, until it changes.

	sleep(1);
	$atime2 = (stat $monitor)[8];
    } until ($atime2 != $atime);

    for $page (@pages) {
	if((stat $page)[8] == $atime2) {
	    return $page;
	}
    }
    return;

} # end monitor()

